#pragma once

#include "AbstractEncoder.h"

#include <vector>
#include <memory>

class DeflateBlock;

class DeflateEncoder : public AbstractEncoder
{
public:
    DeflateEncoder(BitStream* inputStream, BitStream* outputStream);

    ~DeflateEncoder();

    bool encode() override;

    bool decode() override;

private:
    std::vector<std::unique_ptr<DeflateBlock > > mBlocks;
};


