#include "DeflateEncoder.h"

#include "BitStream.h"
#include "DeflateBlock.h"

#include <iostream>

DeflateEncoder::DeflateEncoder(BitStream* inputStream, BitStream* outputStream)
    : AbstractEncoder(inputStream, outputStream)
{

}

DeflateEncoder::~DeflateEncoder()
{

}

bool DeflateEncoder::encode()
{
    return false;
}

bool DeflateEncoder::decode()
{
    auto working_block = std::make_unique<DeflateBlock>(mInputStream, mOutputStream);
    working_block->readHeader();

    DeflateBlock* raw_block = working_block.get();

    while(!raw_block->isFinalBlock())
    {
        break;
    }

    return false;
}

